-- Script for the boss

function GetEntityClassType(self)
  return "RPG_Boss";
end

function OnInitProperties(self)
  -- Model File
  -- self:SetMesh("foo");
  
  -- Entity Properties
  self:SetProperty("m_collisionRadius", 160);
  self:SetProperty("m_collisionHeight", 400);
  self:SetProperty("m_sensorSize", 128);
  self:SetProperty("m_desiredSpeed", 300);
  
  self:SetProperty("m_equipmentAttachmentBoneNames[ES_Weapon]", "right_attachment_jnt");
  self:SetProperty("m_defaultEquipmentScripts[ES_Weapon]", "Scripts/Pickups/RPG_Boss_Claw.lua");
  
  -- base character stats
  self:SetProperty("m_stats.m_strength", 16);
  self:SetProperty("m_stats.m_dexterity", 12);
  self:SetProperty("m_stats.m_spirit", 18);
  self:SetProperty("m_stats.m_vitality", 19);

  -- health
  self:SetProperty("m_stats.m_baseHealth", 1000);
  self:SetProperty("m_stats.m_healthRegenerationEnabled", false);
  self:SetProperty("m_stats.m_unlimitedHealth", false);
  self:SetProperty("m_displayHealth", true);

  -- mana
  self:SetProperty("m_stats.m_baseMana", 30);
  self:SetProperty("m_stats.m_manaRegenerationEnabled", true);

  -- attacks
  self:SetProperty("m_stats.m_baseDamage", 60);

  self:SetProperty("m_actionData.m_rangedAttackProjectileSpeed", 1000);
  self:SetProperty("m_actionData.m_rangedAttackProjectileLaunchBone", "jaw_jnt");

  self:SetProperty("m_actionData.m_aoeAttackDamageMultiplier", 3);
  self:SetProperty("m_actionData.m_aoeAttackRange", 250);
  self:SetProperty("m_actionData.m_aoeAttackManaCost", 10);
  
  self:SetProperty("m_actionData.m_powerAttackDamageMultiplier", 2);
  self:SetProperty("m_actionData.m_powerAttackRange", 550);
  self:SetProperty("m_actionData.m_powerAttackAngle", 10);
  self:SetProperty("m_actionData.m_powerAttackManaCost", 5);
  
  -- ai
  self:SetProperty("m_aggroRadius", 1500);
  self:SetProperty("m_wanderRadius", 1000);

  -- debugging
  self:SetProperty("m_debugDisplayStats", false);
  self:SetProperty("m_debugDisplayMovementInfo", false);
  self:SetProperty("m_debugDisplayInventory", false);
  self:SetProperty("m_debugDisplayBehaviorEvents", false);
  self:SetProperty("m_debugDisplayNavmeshStatus", false);
  self:SetProperty("m_debugDisplayEffectInformation", false);
  self:SetProperty("m_debugDisplayStateInformation", false);

end
