-- Script for the caster guardian

function GetEntityClassType(self)
  return "RPG_CasterGuardian";
end

function OnInitProperties(self)
  -- Model File
  --self:SetMesh("Models\\Guardian_Caster\\Guardian_Caster.model");
  
  -- Entity Properties
  self:SetProperty("m_collisionRadius", 40);
  self:SetProperty("m_collisionHeight", 160);
  self:SetProperty("m_sensorSize", 128);
  self:SetProperty("m_desiredSpeed", 200);
  
  self:SetProperty("m_equipmentAttachmentBoneNames[ES_Weapon]", "right_attachment_jnt");
  self:SetProperty("m_defaultEquipment[ES_Weapon]", "Prefabs\\RPG_Guardian_Caster_Staff_Pickup.vprefab");
  self:SetProperty("m_projectileMeshFilename", "Models\\Effects\\ProjectileStandIn.model");
  
  -- base character stats
  self:SetProperty("m_stats.m_strength", 7);
  self:SetProperty("m_stats.m_dexterity", 7);
  self:SetProperty("m_stats.m_spirit", 16);
  self:SetProperty("m_stats.m_vitality", 14);

  -- health
  self:SetProperty("m_stats.m_baseHealth", 200);
  self:SetProperty("m_stats.m_healthRegenerationEnabled", false);
  self:SetProperty("m_stats.m_unlimitedHealth", false);
  self:SetProperty("m_displayHealth", true);

  -- mana
  self:SetProperty("m_stats.m_baseMana", 30);
  self:SetProperty("m_stats.m_manaRegenerationEnabled", true);

  -- actions
  self:SetProperty("m_stats.m_baseDamage", 30);

  self:SetProperty("m_actionData.m_aoeAttackDamageMultiplier", 3);
  self:SetProperty("m_actionData.m_aoeAttackRange", 250);
  self:SetProperty("m_actionData.m_aoeAttackManaCost", 10);
  
  self:SetProperty("m_actionData.m_powerAttackDamageMultiplier", 2);
  self:SetProperty("m_actionData.m_powerAttackRange", 550);
  self:SetProperty("m_actionData.m_powerAttackAngle", 10);
  self:SetProperty("m_actionData.m_powerAttackManaCost", 5);

  self:SetProperty("m_actionData.m_healProjectileSpeed", 1000);
  self:SetProperty("m_actionData.m_healProjectileLaunchBone", "left_attachment_jnt");
  
  -- ai
  self:SetProperty("m_aggroRadius", 800);
  self:SetProperty("m_wanderRadius", 1000);

  -- debugging
  self:SetProperty("m_debugDisplayStats", false);
  self:SetProperty("m_debugDisplayMovementInfo", false);
  self:SetProperty("m_debugDisplayInventory", false);
  self:SetProperty("m_debugDisplayBehaviorEvents", false);
  self:SetProperty("m_debugDisplayNavmeshStatus", false);
  self:SetProperty("m_debugDisplayEffectInformation", false);
  
  -- Behavior Component
  -- local behaviorComponent = self:AddComponentOfType("vHavokBehaviorComponent");
  
  -- behaviorComponent:SetProperty("m_projectPath", "Behavior\\NonPlayer");
  -- behaviorComponent:SetProperty("m_projectName", "NonPlayer.hkt");
  -- behaviorComponent:SetProperty("m_characterName", "RPG_Guardian_Caster.hkt");
  -- behaviorComponent:SetProperty("m_behaviorName", "RPG_Guardian_Caster_Move.hkt");
  -- behaviorComponent:SetProperty("m_enableRagdoll", true);
  -- behaviorComponent:SetProperty("m_useBehaviorWorldFromModel", true);
  
  -- Misc Components
  -- self:AddComponentOfType("RPG_AttackableComponent");
  -- self:AddComponentOfType("VBlobShadow");
end
