-- Script for the melee guardian

function GetEntityClassType(self)
  return "RPG_MeleeGuardian";
end

function OnInitProperties(self)
  -- Model File
  -- self:SetMesh("foo");
  
  -- Entity Properties
  self:SetProperty("m_collisionRadius", 60);
  self:SetProperty("m_collisionHeight", 160);
  self:SetProperty("m_sensorSize", 128);
  self:SetProperty("m_desiredSpeed", 300);
  
  self:SetProperty("m_equipmentAttachmentBoneNames[ES_Weapon]", "left_attachment_jnt");
  self:SetProperty("m_defaultEquipmentScripts[ES_Weapon]", "Scripts/Pickups/RPG_Guardian_Melee_Polearm.lua");

  self:SetProperty("m_actionData.m_spawnAnimationDelay", 1.8);
  
  -- base character stats
  self:SetProperty("m_stats.m_strength", 12);
  self:SetProperty("m_stats.m_dexterity", 8);
  self:SetProperty("m_stats.m_spirit", 0);
  self:SetProperty("m_stats.m_vitality", 18);

  -- health
  self:SetProperty("m_stats.m_baseHealth", 200);
  self:SetProperty("m_stats.m_healthRegenerationEnabled", false);
  self:SetProperty("m_stats.m_unlimitedHealth", false);
  self:SetProperty("m_displayHealth", true);

  -- mana
  self:SetProperty("m_stats.m_baseMana", 30);
  self:SetProperty("m_stats.m_manaRegenerationEnabled", true);

  -- attacks
  self:SetProperty("m_stats.m_baseDamage", 30);
  
  -- ai
  self:SetProperty("m_aggroRadius", 700);
  self:SetProperty("m_wanderRadius", 1000);

  -- debugging
  self:SetProperty("m_debugDisplayStats", false);
  self:SetProperty("m_debugDisplayMovementInfo", false);
  self:SetProperty("m_debugDisplayInventory", false);
  self:SetProperty("m_debugDisplayBehaviorEvents", false);
  self:SetProperty("m_debugDisplayNavmeshStatus", false);
  self:SetProperty("m_debugDisplayEffectInformation", false);

end
