-- Script for the ranged guardian

function GetEntityClassType(self)
  return "RPG_RangedGuardian";
end

function OnInitProperties(self)
  -- Model File
  -- self:SetMesh("foo");
  
  -- Entity Properties
  self:SetProperty("m_collisionRadius", 40);
  self:SetProperty("m_collisionHeight", 160);
  self:SetProperty("m_sensorSize", 128);
  self:SetProperty("m_desiredSpeed", 400);
  
  self:SetProperty("m_equipmentAttachmentBoneNames[ES_Weapon]", "left_attachment_jnt");
  self:SetProperty("m_defaultEquipmentScripts[ES_Weapon]", "Scripts\\Pickups\\RPG_Guardian_Ranged_Bow.lua");
  -- self:SetProperty("m_projectileMeshFilename", "Models/Guardian_Ranged/Guardian_Ranged_Arrow_Proj.model");

  self:SetProperty("m_actionData.m_spawnAnimationDelay", 1.8);
  
  -- base character stats
  self:SetProperty("m_stats.m_strength", 8);
  self:SetProperty("m_stats.m_dexterity", 12);
  self:SetProperty("m_stats.m_spirit", 0);
  self:SetProperty("m_stats.m_vitality", 16);

  -- health
  self:SetProperty("m_stats.m_baseHealth", 150);
  self:SetProperty("m_stats.m_healthRegenerationEnabled", false);
  self:SetProperty("m_stats.m_unlimitedHealth", false);
  self:SetProperty("m_displayHealth", true);

  -- attacks
  self:SetProperty("m_stats.m_baseDamage", 20);

  self:SetProperty("m_actionData.m_rangedAttackProjectileSpeed", 1000);
  self:SetProperty("m_actionData.m_rangedAttackProjectileLaunchBone", "left_attachment_jnt");
  
  -- ai
  self:SetProperty("m_aggroRadius", 800);
  self:SetProperty("m_wanderRadius", 1000);

  -- debugging
  self:SetProperty("m_debugDisplayStats", false);
  self:SetProperty("m_debugDisplayMovementInfo", false);
  self:SetProperty("m_debugDisplayInventory", false);
  self:SetProperty("m_debugDisplayBehaviorEvents", false);
  self:SetProperty("m_debugDisplayNavmeshStatus", false);
  self:SetProperty("m_debugDisplayEffectInformation", false);

end
